<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/13/2005 *
 * ===================                          Last change: 02/13/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : doubler.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Points doubler                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punkteverdoppler                                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Set module
$GLOBALS['module'] = 'doubler';
$GLOBALS['output_mode'] = '0';

// Load the required file(s)
require('inc/config-global.php');

// Set content type
setContentType('text/html');

// Is the 'doubler' extension active?
redirectOnUninstalledExtension('doubler');

// Init content array
$content = array(
	'message' => '',
);

// Begin with doubler script...
if (isFormSent()) {
	// Secure points (so only integer/double values are allowed
	setPostRequestParameter('points', bigintval(postRequestParameter('points')));

	// Begin with doubling process
	if ((isPostRequestParameterSet('userid')) && (isPostRequestParameterSet('pass')) && (isPostRequestParameterSet('points'))) {
		// Probe for nickname extension and if a nickname was entered
		if (isNickNameUsed(postRequestParameter('userid'))) {
			// Nickname in URL, so load the id
			fetchUserData(postRequestParameter('userid'), 'nickname');
		} else {
			// Direct userid entered
			fetchUserData(postRequestParameter('userid'));
		}

		// Is the data valid?
		if (!isUserDataValid()) {
			// Output message that the userid is not okay
			loadTemplate('admin_settings_saved', false, getMessage('DOUBLER_USERID_INVALID'));
		} // END - if

		// Remove any dots and unwanted chars from the points
		setPostRequestParameter('points', bigintval(round(convertCommaToDot(postRequestParameter('points')))));

		// Probe for enough points
		$probe_points = ((postRequestParameter('points') >= getConfig('doubler_min')) && (postRequestParameter('points') <= getConfig('doubler_max')));

		// Check all together
		if ((isUserDataValid()) && (getUserData('password') == generateHash(postRequestParameter('pass'), substr(getUserData('password'), 0, -40))) && (getUserData('status') == 'CONFIRMED') && ($probe_points)) {
			// Nickname resolved to a unique userid or direct userid entered by the member
			$GLOBALS['doubler_userid'] = getUserData('userid');

			// Calulcate points
			$points = countSumTotalData(getUserData('userid'), 'user_points', 'points') - countSumTotalData(getUserData('userid'), 'user_data', 'used_points');

			// So let's continue with probing his points amount
			if (($points - getConfig('doubler_left') - postRequestParameter('points') * getConfig('doubler_charge')) >= 0) {
				// Enough points are left so let's continue with the doubling process
				// Create doubling "account" width *DOUBLED* points
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_doubler` (`userid`, `refid`, `points`, `remote_ip`, `timemark`, `completed`, `is_ref`) VALUES ('%s','%s','%s','".detectRemoteAddr()."', UNIX_TIMESTAMP(), 'N','N')",
					array(getUserData('userid'), determineReferalId(), bigintval(postRequestParameter('points') * 2)), __FILE__, __LINE__);

				// Subtract entered points
				subtractPoints('doubler', getUserData('userid'), postRequestParameter('points'));

				// Add points to "total payed" including charge
				$points = postRequestParameter('points') - postRequestParameter('points') * getConfig('doubler_charge');
				updateConfiguration('doubler_points', $points, '+');
				incrementConfigEntry('doubler_points', $points);

				// Add second line for the referal but only when userid != refid
				if ((determineReferalId() > 0) && (determineReferalId() != getUserData('userid'))) {
					// Okay add a refid line and apply refid percents
					SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_doubler` (`userid`, `refid`, `points`, `remote_ip`, `timemark`, `completed`, `is_ref`) VALUES ('%s',0,'%s','".detectRemoteAddr()."',UNIX_TIMESTAMP(),'N','Y')",
						array(
							determineReferalId(),
							bigintval(postRequestParameter('points') * 2 * getConfig('doubler_ref'))
						), __FILE__, __LINE__);

					// And that's why we don't want to you more than one referal level of doubler-points. ^^^
				} // END - if

				// Update usage counter
				updateConfiguration('doubler_counter', 1, '+');

				// Set constant
				$content['message'] = loadTemplate('doubler_reflink', true, postRequestParameter('userid'));
			} else {
				// Not enougth points left
				$content['message'] = getMessage('DOUBLER_FORM_NO_POINTS_LEFT');
			}
		} elseif (getUserData('status') == 'CONFIRMED') {
			// Account is unconfirmed!
			$content['message'] = getMessage('DOUBLER_FORM_WRONG_PASS');
		} elseif (getUserData('status') == 'UNCONFIRMED') {
			// Account is unconfirmed!
			$content['message'] = getMessage('DOUBLER_FORM_STATUS_UNCONFIRMED');
		} elseif (getUserData('status') == 'LOCKED') {
			// Account is locked by admin / holiday!
			$content['message'] = getMessage('DOUBLER_FORM_STATUS_LOCKED');
		} elseif (postRequestParameter('points') < getConfig('doubler_min')) {
			// Not enougth points entered
			$content['message'] = getMessage('DOUBLER_FORM_POINTS_MIN');
		} elseif (postRequestParameter('points') > getConfig('doubler_max')) {
			// Too much points entered
			$content['message'] = getMessage('DOUBLER_FORM_POINTS_MAX');
		} elseif (isNickNameUsed(postRequestParameter('userid'))) {
			// Cannot resolv nickname -> userid
			$content['message'] = getMessage('DOUBLER_FORM_404_NICKNAME');
		} else {
			// Wrong password or account not found
			$content['message'] = getMessage('DOUBLER_FORM_404_MEMBER');
		}
	} elseif (!isPostRequestParameterSet('userid')) {
		// Login not entered
		$content['message'] = getMessage('DOUBLER_FORM_404_LOGIN');
	} elseif (!isPostRequestParameterSet('pass')) {
		// Password not entered
		$content['message'] = getMessage('DOUBLER_FORM_404_PASSWORD');
	} elseif (!isPostRequestParameterSet('points')) {
		// points not entered
		$content['message'] = getMessage('DOUBLER_FORM_404_POINTS');
	}
} // END - if (isFormSet())

// Shall I check for points immediately?
if (getConfig('doubler_send_mode') == 'DIRECT') loadInclude('inc/mails/doubler_mails.php');

// Output header
loadIncludeOnce('inc/header.php');

// Banner in text
$content['banner'] = loadTemplate('doubler_banner', true);

// Load header/footer templates
$content['header'] = loadTemplate('doubler_header', true);
$content['footer'] = loadTemplate('doubler_footer', true);

if (isUserDataValid()) {
	// Transfer userid/nickname to constant
	$content['refid'] = getUserData('userid');
} else {
	// Transfer userid/nickname to constant
	$content['refid'] = determineReferalId();
}

// Percent values etc.
$content['charge'] = translateComma(getConfig('doubler_charge') * 100);
$content['ref']    = translateComma(getConfig('doubler_ref') * 100);
$content['total']  = translateComma(getConfig('doubler_points'));
$content['min']    = translateComma(getConfig('doubler_min'));
$content['max']    = translateComma(getConfig('doubler_max'));

// Text "Enter login"
if (isExtensionActive('nickname')) {
	// Choose login/nickname
	$content['enter_login'] = getMessage('GUEST_ENTER_LOGIN_NICKNAME');
} else {
	// Simple login id
	$content['enter_login'] = getMessage('GUEST_ENTER_LOGIN');
}

// Which mail-send-mode did the admin setup?
$content['payout_time'] = getMessage('DOUBLER_PAYOUT_TIME_' . getConfig('doubler_send_mode'));

// Generate table with already payed out doubles
$content['payout_history'] = generateDoublerTable(0, 'Y', 'N', 'DESC');

// Generate timemark
$content['timeout_mark'] = createFancyTime(getConfig('doubler_timeout'));

// Points left to doubler
$content['left'] = translateComma(DOUBLER_GET_TOTAL_POINTS_LEFT());

// Output neccessary form for this
loadTemplate('doubler_index', false, $content);

// Output footer
loadIncludeOnce('inc/footer.php');

// [EOF]
?>
